/* Copyright start
  Copyright (C) 2008 - 2022 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

const puppeteer = require('/opt/cyops-ui/node_modules/puppeteer');
// const puppeteer = require('/home/vagrant/node_modules/puppeteer');
var token = process.argv[4];
const https = require('https');
var options = {
  hostname: 'localhost',
  path: '/api/3/system_settings',
  method: 'GET',
  rejectUnauthorized: false,
  requestCert: false,
  agent: false,
  headers: {'Authorization': 'Bearer '+token}
};

var host;
const req = https.request(options, res => {
  console.log(`statusCode: ${res.statusCode}`)
  var result = '';
  res.on('data', d => {
    result += d
  })

  res.on('end', function () {
    var resultJson = JSON.parse(result);
    var chGlobalValues = resultJson['hydra:member'][0].globalValues;
    if(chGlobalValues && chGlobalValues.hostname && chGlobalValues.hostname.endsWith('/fortisoar')){
      host = 'https://'+chGlobalValues.hostname;
    }else{
      host = 'https://localhost';
    }
  });
})

req.on('error', error => {
  console.error(error)
})

req.end()

var address = process.argv[2];
var filePath = process.argv[3];

address = decodeURIComponent(address) || '';
address = address.replace(/%3A/g, ':');

var qParams = '';
var sIndex = address.indexOf('?');
if(sIndex >= 0 ){
  var addressUrl = address.split('?');
  qParams = addressUrl.length > 1 ? addressUrl[1] : '';
}
else{
  sIndex = address.indexOf('%3F');
  if(sIndex >= 0 ){
    var addressUrl = address.split('%3F');
    qParams = addressUrl.length > 1 ? addressUrl[1] : '';
  }
}
qParams = qParams || '';
var params = qParams.split('&');
var tz = 'Etc/GMT';
for(var iP=0; params && iP < params.length; iP++ ){
  var query = params[iP];
  if(query.indexOf('timezone=')>=0){
    tz = query.split('=')[1];
  }
}
if(!tz || tz.length < 2){
  tz = 'Etc/GMT';
}

function run () {
	 return new Promise(async (resolve, reject) => {
     const args = [
       '--disable-setuid-sandbox',
       '--no-sandbox',
       '--incognito',
       '--headless'
     ];
     const options = {
       args,
       headless: false,
       env:{TZ:tz},
       ignoreHTTPSErrors: true,
       executablePath: '/usr/bin/google-chrome-stable'
     };
     const browser = await puppeteer.launch(options);
    try {


      const page = await browser.newPage();
      // page.on('console', msg => console.log(msg));
      await page.setViewport({width: 1920, height: 1080, deviceScaleFactor: 2})
      await page.setUserAgent(qParams);
	    await page.goto(host+'/login/'+token+'?saml=false&theme=light&qParams='+qParams, {waitUntil: 'networkidle2',timeout: 0});
      await page.waitFor(120000); // 2 minutes delay to render report UI
      await page.evaluate(() => {
        var el = document.getElementById('main-view-template');
        if(!el){
          return false;
        }
        el.classList.add("screenToPrint");
        var body = document.getElementById('bodyId');
        body.appendChild(el);
        var hideElement = document.querySelectorAll(".hideForHeadless");
        for(var index= 0; hideElement && index < hideElement.length;index++){
          hideElement[index].style.display = 'none';
        }
        var bo = document.getElementById('content');
        bo.style.marginLeft = '0';
        bo.style.paddingTop = '0';
        return true;
      });
      await page.waitFor(30000);
      await page.emulateMedia('print');
      await page.pdf({path: filePath,printBackground: true, width:1675});

      await browser.close();
      return resolve(true);
    } catch (e) {
      await browser.close();
      return reject(e);
    }
  })
}
run().then(console.log).catch(console.error);
